//+------------------------------------------------------------------+
//|                                                      HighLow.mq4 |
//|                                                  Victor Nicolaev |
//|                                                    Vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Victor Nicolaev"
#property link      "Vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 3

#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 Yellow

//---- input parameters

extern int CalcPeriod=30;
//---- buffers


double HighBuffer[];
double MidleBuffer[];
double LowBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   //---- drawing settings
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);

   
   SetIndexDrawBegin(0,0);
   SetIndexDrawBegin(1,0);
   SetIndexDrawBegin(2,0);      

      

//---- indicator buffers mapping
   SetIndexBuffer(0,HighBuffer);   
   SetIndexBuffer(1,MidleBuffer);
   SetIndexBuffer(2,LowBuffer);    
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("HighLow");
   SetIndexLabel(0,"High");   
   SetIndexLabel(1,"Midle");   
   SetIndexLabel(2,"Low");
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
int start() {
   int   limit,
         counted_bars=IndicatorCounted();
   limit=Bars-counted_bars;
   if (limit>1)
      limit=Bars-CalcPeriod-1;

   
   for (int i=limit; i>=0; i--) {
      HighBuffer[i]=High[iHighest(NULL,0,MODE_HIGH, CalcPeriod, i)];
      LowBuffer[i] =Low[ iLowest( NULL,0,MODE_LOW,  CalcPeriod, i)];
      MidleBuffer[i]=(HighBuffer[i]+LowBuffer[i])*0.5;
   }
   return(0);
}